#include "MyCPPModule.h"
#include <string>
#include <vector>

static std::vector<char>  // 戻り値はC++のバイト列
  encode_string(const std::string &str,
                char key) {  // 引数はC++の文字列とchar
  const size_t len = str.length();  // 文字列長
  std::vector<char> result(len, 0);  // バイト列の初期化
  for (int i = 0; i < len; i ++) {
    result[i] = str[i] ^ key;  // 文字からバイトへの変換
  }
  return result;  // 変換されたバイト列を戻す
}

@implementation MyCPPModule  // ラッパークラス実装ここから
+ (NSData*)encodeMessage:(NSString*)msg withKey:(char)key {
  const std::string str([msg cStringUsingEncoding:NSUTF8StringEncoding]);
      // Objective-C文字列からC++文字列へ変換
  const std::vector<char> data = encode_string(str, key);  // C++関数を実行
  NSData *data_ = [NSData dataWithBytes:&data[0]
                                 length:data.size()];
      // C++バイト列からObjective-Cデータへ変換
  return data_; // Objective-Cデータを戻す
}
@end  // ラッパークラス実装ここまで
