//
//  main.swift
//  SwiftObjC
//
//  Created by sakira on 2015/02/11.
//  Copyright (c) 2015年 sakira. All rights reserved.
//

import Foundation

println("Hello, World!")

let encoded = MyObjCModule().encodeMessage("abcde", withKey: 0x40)
NSLog("encoded %@", encoded)

class MySwiftModule : MyObjCModule {
  let key: Int8
  init(key: Int8) {
    self.key = key
  }
  func encodeMessage(message: String) -> [Int8] {
    let data = encodeMessage(message, withKey: self.key)
    var bytes:[Int8] = [Int8](count: data.length, repeatedValue:0)
    data.getBytes(&bytes)
    return bytes
  }
}

let enc_mod = MySwiftModule(key: 0x40)
let bytes = enc_mod.encodeMessage("abcd")
NSLog("encoded %@", NSData(bytes: bytes, length: bytes.count))

// code 7.8
extension StructTest {
  func to_s() -> String {
    return "StructTest a:\(a) b:\(b)"
  }
}
extension EnumTest {
  func to_s() -> String {
    return "EnumTest \(self.value)"
  }
}
extension NSEnumTest {
  func to_s() -> String {
    return "NSEnumTest \(rawValue)"
  }
}

// code 7.9
var struct_test = StructTest(a:1, b:2)
struct_test.a = 2
struct_test.b = 3
NSLog("\(struct_test.to_s())")

var enum_test = EnumTestDefault
NSLog("\(enum_test.to_s())")

var myenum_test = NSEnumTest.ZERO
switch (myenum_test) {
case .ZERO:
  NSLog("\(myenum_test.to_s()) ZERO")
case .Foo:
  NSLog("\(myenum_test.to_s()) Foo")
case .Hoge:
  NSLog("\(myenum_test.to_s()) Hoge")
}

// code 7.12
var abcd_data = "abcd".cStringUsingEncoding(NSUTF8StringEncoding)!
encode_string(&abcd_data, Int8(0x40))
NSLog("encoded %@", NSData(bytes: abcd_data, length: 4))

// code 7.16
let encoded2 = MyCPPModule.encodeMessage("abcd", withKey: 0x40)
NSLog("encoded %@", encoded2)

exec_swift()
